package com.ljy.controller;


import com.ljy.domain.Student;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.util.Date;
import java.util.List;

@Controller
public class MyController1 {

    // 该控制器的访问路径为/c1/hello1
    @RequestMapping("/c1/hello1")
    public void helloMVC(){
        System.out.println("hello SpringMVC!");
    }

    // 获取简单类型参数
    @RequestMapping("/c1/param1")
    public void simpleParam(String username,int age){
        System.out.println(username);
        System.out.println(age);
    }

    // 获取对象类型参数
    @RequestMapping("/c1/param2")
    public void objectParam(Student student){
        System.out.println(student);
    }
    // 获取对象关联类型参数
    @RequestMapping("/c1/param3")
    public void objectParam1(Student student){
        System.out.println(student);
    }

    // 封装为简单数据类型的list参数
    @RequestMapping("/c1/param4")
    public void listParam1(@RequestParam List<String> users){
        System.out.println(users);
    }


    // 封装为简单数据类型的数组
    @RequestMapping("/c1/param5")
    public void listParam2(@RequestParam String[] users){
        for (String user : users) {
            System.out.println(user);
        }
    }

    // 封装为简单数据类型的数组
    @RequestMapping("/c1/param6")
    public void listParam3(Student student){
        System.out.println(student);
    }

    // 封装到有map属性的对象中
    @RequestMapping("/c1/param7")
    public void listParam4(Student student){
        System.out.println(student);
    }

    // 使用Servlet原声对象
    @RequestMapping("/c1/param8")
    public void servletParam(HttpServletRequest request, HttpServletResponse response, HttpSession session){
        System.out.println(request.getParameter("name"));
        System.out.println(response.getCharacterEncoding());
        System.out.println(session.getId());
    }

    // 使用Servlet原声对象
    @RequestMapping("/c1/param9")
    public void dataParam(Date birthday){
        System.out.println(birthday);
    }

    @RequestMapping("/cn/code")
    public void code(String username){
        System.out.println(username);
    }


}
