package com.ljy.controller;


import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.ui.ModelMap;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

@Controller
public class MyController2 {

    @RequestMapping("/helloMVC")
    public void helloMVC(){
        System.out.println("hello SpringMVC!");
    }


    @RequestMapping("/c2/hello1")
    public String helloMVC1(){
        System.out.println("hello SpringMVC!");
        return "param";
    }

    @RequestMapping("/c2/hello2")
    public ModelAndView useMVA(){
        System.out.println("返回值类型为ModelAndView");
        // 1.创建ModelAndView对象
        ModelAndView modelAndView = new ModelAndView();
        // 2.获取Model对象,本质是一个Map
        Map<String,Object> model = modelAndView.getModel();
        // 3.使用Model对象向request域设置数据
        model.put("name","吕金洋");
        // 4.使用View树对象设置跳转的路径
        modelAndView.setViewName("ljy");
        return modelAndView;
    }


    @RequestMapping("/c2/hello3")
    public String setRequestModel(HttpServletRequest request){
        request.setAttribute("name","吕金洋");
        return "ljy";
    }

    @RequestMapping("/c2/hello4")
    public String setRequestModel2(Model model, ModelMap modelMap){
        // model.addAttribute("name","王慧莹");
        modelMap.addAttribute("name","吕金洋1");
        return "ljy";
    }

    @RequestMapping("/c2/hello5")
    public String setRequestModel3(Map map){
        map.put("name","hello吕金洋");
        return "ljy";
    }

    @RequestMapping("/c2/hello6")
    public String setSessionModel(HttpSession session){
        session.setAttribute("address","北京");
        return "ljy";
    }

    @RequestMapping("/c2/hello7")
    public String setContextModel(HttpSession session){
        ServletContext servletContext = session.getServletContext();
        servletContext.setAttribute("age",15);
        return "ljy";
    }

    @RequestMapping("/c2/hello8")
    public void myForward1(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        request.setAttribute("name","吕金洋");
        // 请求转发
        // request.getRequestDispatcher("/c2/hello9").forward(request, response);
        response.sendRedirect("/c2/hello9");
    }

    @RequestMapping("/c2/hello9")
    public void myForward2(HttpServletRequest request, HttpServletResponse response){
        System.out.println("hello");
        System.out.println(request.getAttribute("name"));
    }

    @RequestMapping("/c2/hello10")
    public String myForward3(HttpServletRequest request){
        request.setAttribute("name","吕金洋");
        // 请求转发
        // return "forward:/c2/hello9";
        // 重定向
        return "redirect:/c2/hello9";
    }
}
